import org.junit.Test;

import static org.junit.Assert.*;

public class TrieExerciseTest {

    @Test
    public void addWordToTrie() {
        TrieExercise trie = new TrieExercise();
        trie.addWordToTrie("add");
        trie.addWordToTrie("bag");
        trie.addWordToTrie("badge");
        TrieExercise.TrieNode root = trie.getRoot();
        assertNotNull(root.children[0]);
        assertNotNull(root.children[0].children[3]);
        assertNotNull(root.children[0].children[3].children[3]);
        assertTrue(root.children[0].children[3].children[3].endOfWord);
        assertNotNull(root.children[1]);
        assertNotNull(root.children[1].children[0]);
        assertNotNull(root.children[1].children[0].children[6]);
        assertNotNull(root.children[1].children[0].children[3].children[6].children[4]);
        assertTrue(root.children[1].children[0].children[6].endOfWord);
        assertTrue(root.children[1].children[0].children[3].children[6].children[4].endOfWord);
    }

    @Test
    public void searchTrie() {
        TrieExercise trie = new TrieExercise();
        trie.addWordToTrie("add");
        trie.addWordToTrie("bag");
        trie.addWordToTrie("badge");

        assertTrue(trie.searchTrie("add"));
        assertTrue(trie.searchTrie("bag"));
        assertTrue(trie.searchTrie("badge"));

        assertFalse(trie.searchTrie("bad"));
        assertFalse(trie.searchTrie("dad"));
    }
}